var GpxFile_poly;
function parseGpx(file){
  //zkontrolujeme, zda je to gpx soubor
  //alert('Nacteni GPX souboru: '+file.name);
  if((GpxFile_poly!=undefined)){ GpxFile_poly.remove(map);}
  var lat,lon;
  var color;
  var bTrack=false;
  var reader=new FileReader();
  reader.readAsText(file,'UTF-8'); //nacteme soubor (predpokladame v utf-8)
  var xml='';
  reader.onload=readerEvent => {
    xml=readerEvent.target.result; //toto je nacteny obsah
    //console.log("-nacteno---\n"+xml);
    var parser=new DOMParser();
    var gpx=parser.parseFromString(xml, "text/xml");
    var aLatLon=[];
    var aSeg=gpx.getElementsByTagName("trkseg"); //nacte vsechny segmenty <trksek>
    //pokud je tu stopa, zobrazime ji
    for(var seg of aSeg){ //projdeme vsechny segmenty
      var aTrkpt=seg.getElementsByTagName("trkpt"); //nacteme vsechny body segmentu
      for(var wpt of aTrkpt){ //z kazdeho bodu nacteme lat a lon hodnotu
        lat=wpt.getAttribute("lat");
        lon=wpt.getAttribute("lon");
        var latlon=[lat,lon];
        aLatLon.push(latlon);
        bTrack=true;
        color="rgb(100,100,255)";
      }
    }
    //pokud nejde o stopu, zkusime zpracovat jako (planovanou) trasu
    if(bTrack==false){
      //var rte=gpx.getElementsByTagName("rte");
      var aRtept=gpx.getElementsByTagName("rtept"); //nacteme vsechny body segmentu
      for(var wpt of aRtept){ //z kazdeho bodu nacteme lat a lon hodnotu
        lat=wpt.getAttribute("lat");
        lon=wpt.getAttribute("lon");
        var latlon=[lat,lon];
        aLatLon.push(latlon);
      }
      bTrack=true;
      color="rgb(255,100,100)";
    }
    if(bTrack){
      GpxFile_poly=L.polyline(aLatLon, {color: color, weight: 4, smoothFactor: 1}).addTo(map);
    }
    else alert("ERR: Soubor neobsahuje zobrazitelnou stopu.");
    //alert('Nacten soubor '+file.name);
  }
}

function loadForEdit(){
  //zkusime neco pridat
  var latlngs=[
    [50.0, 14.3],
    [50.1, 14.3],
    [50.0, 14.4],
    [50.1, 14.4]
  ];
  var color=getColor(true);
  latlngs.push([50.0,14.5]);          //zmenime pole souradnice
  /* 1111
  //nasledujici prikaz vytvori polyline a prida do mapy, zaroven vykresli
  //ale neprida do k editaci. Je treba
  //var poly=L.polyline(latlngs, {color: 'red'}).addTo(map);

  var poly=L.polyline(latlngs, {color: 'red'});


  poly.layerType='polyline';

  map.addLayer(poly);         //zobrazime
  //map.removeLayer(polyline);//skryti polyline

  //toto volani zkolabuje, pri pridavani eventu na tlacitko remove
  //(nedefinovana funkce addEventListener(), takze asi spatne vytvorene 'poly',
  //nema poly.layer)
  var cells=addFeatureEntry((++lineCounter_),color,poly);
  latlngs.push([50.0,14.5]);          //zmenime pole souradnice
  poly.layer.setLatLngs(latlngs);    //promitneme zmenu
  updatePolyline(poly.layer,cells);  //aktualizace radku v tabulce pro upravu
  poly.layer.addEventListener('edit', function(){ //pridame obsluhu editace
    updatePolyline(layer, cells);
  });
  1111 */
  /* 22222
  //vytvoreni je pres event, priklad 24 v odkazu
  //https://stackoverflow.com/questions/22730888/how-to-click-a-button-and-start-a-new-polygon-without-using-the-leaflet-draw-ui
  var poly=new L.Draw.Polyline(map, {});
  poly.layerType='polyline';
  poly.layer.setLatLngs(latlngs);    //promitneme zmenu
  //poly.enable();
  2222 */
  //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  //najdeme editacni layer, kam pridat caru
  /* 3333
  var i=0;
  var b=0;
  map.eachLayer(function(layer){
    //pokud existuje className
    if(typeof layer._container!=="undefined"){
   	  //if(layer._container.className=="leaflet-layer"){
        if(b==0){
          L.polyline(latlngs,{color:"red"}).addTo(layer); //prida caru do editacniho layeru misto do mapy
          b=1;
        }
      //}
    }
    i=i+1;
  });
  alert('Pocet layer: '+i);
  3333 */
  //pridani editovatelneho ctverce je na  !!!!!!!!!!!!
  //https://stackoverflow.com/questions/44036712/add-polygon-programmatically-in-leaflet-l-draw-plugin
  /* 4444
  //toto prida ale cele nove prostredi vcetne toolbaru
  var editableLayers=L.featureGroup().addTo(map);
  var drawControl = new L.Control.Draw({  //novy toolbar pro obsluhu tohoto editacniho layeru
    edit: {
      featureGroup: editableLayers
    },
    draw: false
  }).addTo(map);
  //pridame novou editovatelnou caru
  L.polyline(latlngs,{color:"red"}).addTo(editableLayers); //prida caru do editacniho layeru misto do mapy
  4444 */
}

function stringToFile(str,fileName){
  document.getElementById('iGpxTxt').value=str; //ulozime text do prvku formulare
  var textFile=null;
  var makeTextFile=function(text){
    var data=new Blob([text], {type: 'text/plain'});
    // If we are replacing a previously generated file we need to
    // manually revoke the object URL to avoid memory leaks.
    if(textFile!==null){
      window.URL.revokeObjectURL(textFile);
    }
    textFile=window.URL.createObjectURL(data);
    return textFile;
  };
  var create=document.getElementById('create');
  var txt=document.getElementById('iGpxTxt');
  var link=document.createElement('a');
  link.setAttribute('download', fileName);
  link.href=makeTextFile(txt.value);
  document.body.appendChild(link);
  //pockame na pridani <a> do dokumentu
  window.requestAnimationFrame(function () {
    var event = new MouseEvent('click');
    link.dispatchEvent(event);
    document.body.removeChild(link);
  });
}

function frac(f) { return f % 1;} //necha jen desetinnou cast z cisla
function ssmmddd(lat,lon){ //prevede desetinny formaf cisla na SS°mm.ddd
  var str;
  if(lat<0){ str='S'; lat=-lat;} else str='N';
  str=str+Math.floor(lat)+'°';  //soubor je v UTF-8, takze ten stupen taky!
  lat=60.*frac(lat);
  str=str+lat.toFixed(3)+', ';
  //lon;
  if(lon<0){ str='W'; lon=-lon;} else str=str+'E';
  str=str+Math.floor(lon)+'°'; //soubor je v UTF-8, takze ten stupen taky!
  lon=60.*frac(lon);
  str=str+lon.toFixed(3);
  return(str);
}

function saveCoords(format){ //ulozi souradnice ve zvolenem formatu
                                //0=CSV, 1=stopa, 2=trasa, 3=CSV ve formaty SS°mm.ddd
  hideGpxSaveForm();
  var id=document.getElementById('iGpxSaveId').text;
  map.eachLayer(function(layer){  //projdeme vsechny layer a najdeme ten spravny podle id
    if(layer._leaflet_id==id){
      var a=layer.getLatLngs();
      //if(layer instanceof L.Polyline){
      //  alert('Polyline Layer: pocet bodu: '+a.length+', '+layer.options.color+', '+layer._leaflet_id);
      //}
      if(layer instanceof L.Polygon){
        a=a[0]; //v polygonu je pole poli souradnic, pouzijeme prvni z nich
      //  alert('Polygon Layer: pocet bodu: '+a.length+', '+layer.options.color+', '+layer._leaflet_id);
      }
      if(a.length>1){ //ukladat 1 bod nejde, mozna je to od polygonu
        var sGpx='';
        for(var i=0; i<a.length; i++){
          if(format==0) s=a[i].lat+', '+a[i].lng;
          if(format==1) s='<trkpt lat="'+roundVal(a[i].lat)+'" lon="'+roundVal(a[i].lng)+'"></trkpt>';
          if(format==2) s='<rtept lat="'+roundVal(a[i].lat)+'" lon="'+roundVal(a[i].lng)+'"></rtept>';
          if(format==3) s=ssmmddd(a[i].lat,a[i].lng);
          sGpx=sGpx+s+"\r\n";
        };
        var dt=new Date();     var year=dt.getFullYear();  var month=dt.getMonth()+1;
        var day=dt.getDate(); var hour=dt.getHours();     var minute=dt.getMinutes();
        var second=dt.getSeconds();
        if(month.toString().length==1){ month='0'+month;}
        if(day.toString().length==1){ day='0'+day;}
        if(hour.toString().length==1){ hour='0'+hour;}
        if(minute.toString().length==1){ minute='0'+minute;}
        if(second.toString().length==1){ second='0'+second;}
        var dateTime = year+'/'+month+'/'+day+' '+hour+':'+minute+':'+second;
        //obalime data, pokud je to potreba
        if(format==1) sGpx="<trk><trkseg>\r\n"+sGpx+"</trkseg>\r\n</trk>\r\n";
        if(format==2) sGpx="<rte>\r\n"+sGpx+"</rte>\r\n";
        //pro GPX jeste hlavicka a paticka
        if(format==1 || format==2){
          sGpx="<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\" ?>\r\n"
            +"<gpx xmlns=\"http://www.topografix.com/GPX/1/1\" "
            +"xmlns:gpxx=\"http://www.garmin.com/xmlschemas/GpxExtensions/v3\" "
            +"xmlns:gpxtpx=\"http://www.garmin.com/xmlschemas/TrackPointExtension/v1\" "
            +"creator=\"GeoGet, ggmap, GpxFile\" version=\"1.1\" "
            +"xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" "
            +"xsi:schemaLocation=\"http://www.topografix.com/GPX/1/1 http://www.topografix.com/GPX/1/1/gpx.xsd http://www.garmin.com/xmlschemas/GpxExtensions/v3 http://www.garmin.com/xmlschemas/GpxExtensionsv3.xsd http://www.garmin.com/xmlschemas/TrackPointExtension/v1 http://www.garmin.com/xmlschemas/TrackPointExtensionv1.xsd\">\r\n"
            +"<metadata>\r\n"
            +"  <time>"+year+'-'+month+'-'+day+'T'+hour+':'+minute+':'+second+"Z</time>\r\n"
            +"</metadata>\r\n"
            +sGpx+"</gpx>\r\n";
        }
        if(format==0 || format==3) stringToFile(sGpx,'polyline.csv');
        if(format==1) stringToFile(sGpx,'trace.gpx');
        if(format==2) stringToFile(sGpx,'route.gpx');
      }
    }
  });
}
function saveAsFile(id,format){
  //zapiseme do formulare hodnotu id
  document.getElementById('iGpxSaveId').text=id;
  //zobrazime formular
  document.getElementById('iGpxSaveForm').style.display='block';
}

function hideGpxSaveForm(){
  document.getElementById('iGpxSaveForm').style.display='none';
}

function addForm() {
	form='<div id="iGpxForm" class="noprint leaflet-control-layers movable">'
      +'<img id="iGpxLoad" title="Zobrazení GPX souboru" alt="Zobrazení GPX souboru" src="plugin/GpxFile/gpx-24.png" />'
/* ### ukladani polyline do GPX nebo CSV
      +'<img id="iGpxEdit" title="Zobrazení GPX souboru z možností úpravy" alt="Načtení GPX souboru z možností úpravy" src="plugin/GpxFile/edit.png" />'
      +'<img id="iGpxRoute" title="Uložení stopy do GPX" alt="Uložení stopy do GPX" src="plugin/GpxFile/route.png" />'
      +'<img id="iGpxTrace" title="Uložení trasy do GPX" alt="Uložení trasy do GPX" src="plugin/GpxFile/trace.png" />'
      +'<img id="iGpxCsv" title="Uložení souřadnic do CSV" alt="Uložení souřadnic do CSV" src="plugin/GpxFile/csv.png" />'
*/
	    +'</div>'
      //cast pouzita pro ukladani do souboru, neni zobrazeno, ale pouziva se
      +'<div display="none"><textarea id="iGpxTxt"></textarea><button id="create"></button></div>'
      //cast pouzita pro volbu typu ulozeneho souboru
      +'<div id="iGpxSaveForm" class="noprint">'
      +'<div id="iGpxSaveTitle">Uložit jako ...<a class="close" onclick="hideGpxSaveForm();">×</a></div>'
      +'<p><span id="iGpxSaveId"></span>' //id objektu, ktery prijde ulozit
      +'<button onclick="saveCoords(1);">Stopu</button><br />'
      +'<button onclick="saveCoords(2);">Trasu</button><br />'
      +'<button onclick="saveCoords(0);">CSV (SS.dddddd)</button><br />'
      +'<button onclick="saveCoords(3);">CSV (SS°MM.ddd)</button><br />'
      +'</p></div>'
      ;
  $('#filter-panel').after(form); //vlozime div s ikonkou
 	// obsluha tlacitka Load GPX
	$("#iGpxLoad").click(function(){
    var input=document.createElement('input');
    input.type='file';
    input.onchange = e => {
      parseGpx(e.target.files[0]);
    };
    input.click();
	});
  $("#iGpxEdit").click(function(){
    loadForEdit(); //pridani cary na mapu
  });
  //obsluha vytvoreni noveho kresleneho objektu tak, abych ho pripadne mohl ulozit
  //(prida na radek tabulky v Draws ikonku pro ulozeni)
  map.on(L.Draw.Event.CREATED, function (poly) {
    var eTr=document.getElementById('ftr_'+lineCounter_);
    //pred vzdalenost pridame novy td s tlacitkem pro ulozeni
    //element pridavame vzdy, ale to tlacitko jen pro polyline
    var tdSave = document.createElement("td");
    eTr.insertBefore(tdSave,eTr.lastElementChild);
    if(poly.layerType=="polyline" || poly.layerType=="polygon"){
      tdSave.innerHTML='<div class="cGpxButSave" onclick="saveAsFile('
        +poly.layer._leaflet_id+');"></div>';
    }
  });
}

function GpxFile_ggm_init() {
	loadcss('plugin/GpxFile.css');
  //ggmregister('onmap', alert('SSSSSS'));
	ggmregister('onmap', function() {
		addForm();
	});
}
